﻿Imports SaveConverterNDS
Imports SaveFormatInterface
Imports SaveFormatInterface.Interfaces
Partial Class data_newcontrols_NDS_Save_Converter_new
    Inherits System.Web.UI.UserControl 'BasePlugin
    Dim _debugmode As Boolean = False
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'If Not My.User.IsAuthenticated Then
        '    Response.Redirect("l.aspx")
        'End If
        If Not Page.IsPostBack Then
             Dim formats As Generic.List(Of Interfaces.SaveFormat) = SaveConverterNDS.Converter.GetSaveFormats
            Dim formatlist(formats.Count - 1) As String
            For count As Integer = 0 To formats.Count - 1
                formatlist(count) = formats(count).FriendlyName
            Next
            Array.Sort(formatlist, 1, formatlist.Length - 1)
            For Each item In formatlist
                cbTarget.Items.Add(item)
                cbSource.Items.Add(item)
            Next
            For Each item In SaveConverterNDS.SizeManager.SizeArray
                cbSize.Items.Add(item)
            Next
            cbTarget.SelectedIndex = 0
            cbSource.SelectedIndex = 0
            cbSize.SelectedIndex = 0
            'If My.User.IsAuthenticated Then
            '    cbTarget.AutoPostBack = Not Profile.LightMode
            '    ARDSi.Visible = Profile.LightMode
            'End If
        End If
        If _debugmode Then
            Label1.Text = "Debug Mode"
        Else
            Label1.Text = ""
        End If
        'If My.User.IsAuthenticated Then
        '    ARDSi.Visible = Membership.Permissions.IsGBNetUser
        'Else
        '    ARDSi.Visible = False
        'End If
    End Sub

    Function ListContains(ByVal List As Generic.List(Of SaveFormat), ByVal FindID As String) As Boolean
        Dim value As Boolean = False
        For Each Item As Save_File_Converter.Converter.SaveFormat In List
            If Item.ID = FindID Then
                Return True
                Exit Function
            End If
        Next
        Return value
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim DebugReport As String = "NDS Conversion:" & vbCrLf
        If _debugmode Then
            If Not IO.Directory.Exists(Server.MapPath("~/data/debug/" & My.User.Name & "/")) Then
                IO.Directory.CreateDirectory(Server.MapPath("~/data/debug/" & My.User.Name & "/"))
            End If
            IO.File.WriteAllBytes(Server.MapPath("~/data/debug/" & My.User.Name & "/") & "[Upload]" & FileUpload1.FileName, FileUpload1.FileBytes)
            DebugReport += "[" & Date.UtcNow.ToString & "] Uploaded file """ & FileUpload1.FileName & """ (" & FileUpload1.FileBytes.Length & " bytes)" & vbCrLf
        End If
        Dim SourceFormat As SaveFormat = SaveConverterNDS.Converter.GetSaveFormatByFriendlyName(cbSource.SelectedItem.Text)
        Dim TargetFormat As SaveFormat = SaveConverterNDS.Converter.GetSaveFormatByFriendlyName(cbTarget.SelectedItem.Text)
        
        SourceFormat.IsOnline = True
        TargetFormat.IsOnline = True
        TargetFormat.ExtendedData = (TextBox1.Text.Replace("_", "__").Replace("ÿ", "_y") & "ÿ" & TextBox2.Text.Replace("_", "__").Replace("ÿ", "_y") & "ÿ" & TextBox3.Text.Replace("_", "__").Replace("ÿ", "_y"))

        Dim size As Integer
        size = SaveConverterNDS.SizeManager.Size(SaveConverterNDS.SizeManager.SizeArray(cbSize.SelectedIndex))
        If _debugmode Then
            DebugReport += "[" & Date.UtcNow.ToString & "] Source Format: " & SourceFormat.FriendlyName & "; Target Format: " & TargetFormat.FriendlyName & "; Target Size: " & cbSize.SelectedItem.Text & "; Extended Data: " & (TextBox1.Text.Replace("_", "__").Replace("ÿ", "_y") & "ÿ" & TextBox2.Text.Replace("_", "__").Replace("ÿ", "_y") & "ÿ" & TextBox3.Text.Replace("_", "__").Replace("ÿ", "_y")) & vbCrLf
        End If
        Dim filename As String = IO.Path.GetFileNameWithoutExtension(FileUpload1.FileName) & "." & TargetFormat.FileExtension
        Dim output As Byte() = SaveConverterNDS.Converter.Convert(FileUpload1.FileBytes, SourceFormat, TargetFormat, size)
        If _debugmode Then
            Dim g As Guid = Guid.NewGuid
            IO.File.WriteAllBytes(Server.MapPath("~/data/debug/" & My.User.Name & "/") & "[Converted]" & filename, output)
            DebugReport += "[" & Date.UtcNow.ToString & "] Converted to file """ & filename & """ (" & output.Length & " bytes)"
            IO.File.WriteAllText(Server.MapPath("~/data/debug/" & My.User.Name & "/") & g.ToString & "-ConversionDebugReport.txt", DebugReport)
            Label1.Text = "Debug Mode.  Last Conversion ID: " & g.ToString
            filename = IO.Path.GetFileNameWithoutExtension(FileUpload1.FileName) & "-ConversionID(" & g.ToString & ")" & "." & TargetFormat.FileExtension
        End If
        Response.AddHeader("content-disposition", "attachment; filename=" & filename)
        Response.ContentType = "application/octet-stream"
        Response.OutputStream.Write(output, 0, output.Length)
        Response.End()
    End Sub

    Protected Sub cbTarget_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbTarget.SelectedIndexChanged
        'If My.User.IsAuthenticated Then
        '    If Not Profile.LightMode Then
        '        ARDSi.Visible = (Converter.GetSaveFormatByFriendlyName(cbTarget.Items(cbTarget.SelectedIndex).Text, False).ID = "ARDSMEUSDUC")
        '    End If
        'Else
        '    ARDSi.Visible = (Converter.GetSaveFormatByFriendlyName(cbTarget.Items(cbTarget.SelectedIndex).Text, False).ID = "ARDSMEUSDUC")
        'End If
    End Sub

    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim TargetFormat As SaveFormat = SaveConverterNDS.Converter.GetSaveFormatByFriendlyName(cbTarget.SelectedItem.Text)
        cbSize.Items.Clear()
        If TargetFormat.FileSize.Length = 0 Then
            For Each item In SaveConverterNDS.SizeManager.SizeArray
                cbSize.Items.Add(item)
            Next
        Else
            For Each item As Integer In TargetFormat.FileSize
                cbSize.Items.Add(SaveConverterNDS.SizeManager.GetStringFromInteger(item))
            Next
        End If
        cbSize.SelectedIndex = 0
    End Sub
End Class
